/**
 * This work is provided under the terms of the CREATIVE COMMONS PUBLIC
 * LICENSE. This work is protected by copyright and/or other applicable
 * law. Any use of the work other than as authorized under this license
 * or copyright law is prohibited.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * © 2016 OX Software GmbH, Germany. info@open-xchange.com
 *
 * @author David Bauer <david.bauer@open-xchange.com>
 * @author Julian Bäume <julian.baeume@open-xchange.com>
 */

module.exports = function (grunt) {
    'use strict';

    // do not start any heavy operation when configs change. Developer is responsible, instead
    grunt.config.set('watch.configs.files', []);
    var prefixes = grunt.config('local.appserver.prefixes').slice(1);
    grunt.config.extend('watch', {
        prefixes: {
            options: {},
            files: prefixes.map(function (p) {
                return require('path').join(p, '**/*');
            }),
            tasks: ['force_update']
        }
    });
};
